Index: boost/logging/format/formatter/thread_id.hpp
===================================================================
--- boost/logging/format/formatter/thread_id.hpp	(Revision 40614)
+++ boost/logging/format/formatter/thread_id.hpp	(Arbeitskopie)
@@ -22,6 +22,26 @@
 #endif
 
 #include <boost/logging/detail/fwd.hpp>
+/*
+|| LANG=C g++-3.4 -I. -I/home/jens/Programme/Entwicklung/Boost/svn/trunk/ -Wall -pedantic -Wcast-align -Wpointer-arith -W main.cpp -o all	
+|| In file included from main.cpp:3:
+boost/logging/format/formatter/thread_id.hpp|37| error: `do_convert_format' has not been declared
+boost/logging/format/formatter/thread_id.hpp|37| error: `prepend' has not been declared
+boost/logging/format/formatter/thread_id.hpp|37| error: expected class-name before ',' token
+boost/logging/format/formatter/thread_id.hpp|37| error: `boost::logging::op_equal' has not been declared
+boost/logging/format/formatter/thread_id.hpp|37| error: expected class-name before '{' token
+|| boost/logging/format/formatter/thread_id.hpp: In member function `void boost::logging::formatter::thread_id_t<convert>::operator()(msg_type&) const':
+boost/logging/format/formatter/thread_id.hpp|44| error: no match for 'operator<<' in 'out << (const boost::logging::char_type*)(boost::logging::ansi_unicode_char_holder("[T", "[\000\000\000T\000\000\000\000\000\000"))'
+boost/logging/format/formatter/thread_id.hpp|50| error: invalid use of undefined type `struct std::basic_ostringstream<char, std::char_traits<char>, std::allocator<char> >'
+/usr/include/c++/3.4/iosfwd|80| error: declaration of `struct std::basic_ostringstream<char, std::char_traits<char>, std::allocator<char> >'
+|| boost/logging/format/formatter/thread_id.hpp: At global scope:
+boost/logging/format/formatter/thread_id.hpp|55| error: template argument 1 is invalid
+boost/logging/format/formatter/thread_id.hpp|55| error: ISO C++ forbids declaration of `thread_id' with no type
+|| make: *** [all] Fehler 1
+*/
+#include <boost/logging/format/formatter/convert_format.hpp> // do_convert_format
+#include <boost/logging/detail/manipulator.hpp> // is_generic
+#include <sstream> // std::basic_ostringstream
 
 namespace boost { namespace logging { namespace formatter {
 
Index: boost/logging/format/formatter/defaults.hpp
===================================================================
--- boost/logging/format/formatter/defaults.hpp	(Revision 40614)
+++ boost/logging/format/formatter/defaults.hpp	(Arbeitskopie)
@@ -24,6 +24,16 @@
 #include <boost/logging/detail/fwd.hpp>
 #include <boost/logging/detail/manipulator.hpp>
 #include <boost/logging/format/formatter/time.hpp>
+/*
+|| LANG=C g++-3.4 -I. -I/home/jens/Programme/Entwicklung/Boost/svn/trunk/ -Wall -pedantic -Wcast-align -Wpointer-arith -W main.cpp -o all	
+|| In file included from main.cpp:3:
+|| boost/logging/format/formatter/defaults.hpp: In member function `void boost::logging::formatter::idx_t<convert>::operator()(msg_type&) const':
+boost/logging/format/formatter/defaults.hpp|60| error: no match for 'operator<<' in 'idx << (const boost::logging::char_type*)(boost::logging::ansi_unicode_char_holder("[", "[\000\000\000\000\000\000"))'
+boost/logging/format/formatter/defaults.hpp|62| error: invalid use of undefined type `struct std::basic_ostringstream<char, std::char_traits<char>, std::allocator<char> >'
+/usr/include/c++/3.4/iosfwd|80| error: declaration of `struct std::basic_ostringstream<char, std::char_traits<char>, std::allocator<char> >'
+|| make: *** [all] Fehler 1
+*/
+#include <sstream> // std::basic_ostringstream
 #include <stdio.h>
 #include <time.h>
 
Index: boost/logging/detail/raw_doc/acknowledgments.hpp
===================================================================
--- boost/logging/detail/raw_doc/acknowledgments.hpp	(Revision 40614)
+++ boost/logging/detail/raw_doc/acknowledgments.hpp	(Arbeitskopie)
@@ -9,7 +9,7 @@
 - Charles Brockman - for thoroughly analyzing the docs
 - Darryl Green - for giving me lots of feedback and showing me other ways to solve things
 - Caleb Epstein - for porting parts of my code to any non-Windows OS, and implementing several formatters and destinations
-- Stefan Slapeta and Bill Wade and a lot of others for giving me early feedback.
+- Stefan Slapeta and Bill Wade and a lot of others for giving me early feedback
 - Pavel Vozelinek - for very thourough reviews and lots of comments
 - Pavel Savara - for feedback about docs, thread-safety and gcc
 - Jens Seidel - for helping me with issues with gcc (different versions), and extra feedback
Index: boost/logging/writer/format_write.hpp
===================================================================
--- boost/logging/writer/format_write.hpp	(Revision 40614)
+++ boost/logging/writer/format_write.hpp	(Arbeitskopie)
@@ -23,6 +23,42 @@
 
 #include <boost/logging/detail/fwd.hpp>
 #include <boost/type_traits/is_base_of.hpp>
+/*
+|| LANG=C g++-3.4 -I. -I/home/jens/Programme/Entwicklung/Boost/svn/trunk/ -Wall -pedantic -Wcast-align -Wpointer-arith -W main.cpp -o all	
+|| In file included from main.cpp:3:
+boost/logging/writer/format_write.hpp|122| error: `boost::logging::format_and_write' has not been declared
+boost/logging/writer/format_write.hpp|122| error: `simple' has not been declared
+boost/logging/writer/format_write.hpp|122| error: expected `>' before '<' token
+boost/logging/writer/format_write.hpp|122| error: expected unqualified-id before ',' token
+boost/logging/writer/format_write.hpp|245| error: extra `;'
+|| In file included from boost/logging/writer/format_write.hpp:252,
+||                  from main.cpp:3:
+./boost/logging/detail/use_format_write.hpp|39| error: `boost::logging::format_and_write' has not been declared
+./boost/logging/detail/use_format_write.hpp|39| error: expected nested-name-specifier before "simple"
+./boost/logging/detail/use_format_write.hpp|39| error: ISO C++ forbids declaration of `simple' with no type
+./boost/logging/detail/use_format_write.hpp|39| error: expected `;' before '<' token
+./boost/logging/detail/use_format_write.hpp|40| error: `msg_route' has not been declared
+./boost/logging/detail/use_format_write.hpp|40| error: expected nested-name-specifier before "simple"
+./boost/logging/detail/use_format_write.hpp|40| error: ISO C++ forbids declaration of `simple' with no type
+./boost/logging/detail/use_format_write.hpp|40| error: expected `;' before '<' token
+./boost/logging/detail/use_format_write.hpp|47| error: `boost::logging::format_and_write' has not been declared
+./boost/logging/detail/use_format_write.hpp|47| error: expected nested-name-specifier before "use_cache"
+./boost/logging/detail/use_format_write.hpp|47| error: ISO C++ forbids declaration of `use_cache' with no type
+./boost/logging/detail/use_format_write.hpp|47| error: expected `;' before '<' token
+./boost/logging/detail/use_format_write.hpp|48| error: `msg_route' has not been declared
+./boost/logging/detail/use_format_write.hpp|48| error: expected nested-name-specifier before "with_route"
+./boost/logging/detail/use_format_write.hpp|48| error: ISO C++ forbids declaration of `with_route' with no type
+./boost/logging/detail/use_format_write.hpp|48| error: expected `;' before '<' token
+./boost/logging/detail/use_format_write.hpp|99| error: `format_write' is not a member of `boost::logging::writer'
+./boost/logging/detail/use_format_write.hpp|99| error: `format_write' is not a member of `boost::logging::writer'
+./boost/logging/detail/use_format_write.hpp|105| error: wrong number of template arguments (5, should be 2)
+./boost/logging/detail/format_msg_type.hpp|31| error: provided for `template<class gather_msg, class write_msg> struct boost::logging::logger'
+./boost/logging/detail/use_format_write.hpp|105| error: expected `{' before '>' token
+./boost/logging/detail/use_format_write.hpp|105| error: expected unqualified-id before '>' token
+./boost/logging/detail/use_format_write.hpp|120| error: extra `;'
+|| make: *** [all] Fehler 1
+*/
+#include <boost/logging/format.hpp> // format_and_write::simple
 
 namespace boost { namespace logging {
 